// {{{ copyright notice
// }}}
// {{{ file documentation
/** 
 * @file
 * @brief Defines various painting operations
 */
// }}}

#ifndef _LEAR_PIMAGE_H_
#define _LEAR_PIMAGE_H_


namespace lear {

class Painter;
/**
 * @brief PImage class. Mainly for use by Painter
 */
class PImage {
#define NI fprintf(stderr,"Not implemented %s:%d\n",__FILE__,__LINE__)
    public:
    PImage() {}
    PImage(const std::string& imagename){
        load(imagename);
    }
    PImage(int w, int h, int depth=32);

    void load(const std::string& imagename) ;
    int width() const {
      NI;
      return -1;
    }
    int height() const {
      NI;
      return -1;
    }

    PImage crop( int x, int y, int width, int height){
      NI;
      return PImage();
    }

    typedef unsigned char DATA8;
    typedef unsigned int DATA32;
   

    DATA32* data(){
      NI;
      return 0;
    }
    // data must be the pointer returned by DATA32* data() function
    bool data(DATA32* data){
      NI;
      return data;
    }
    int depth() const { return 32; }
    int rows() const { return width(); }
    int cols() const { return height(); }
    bool valid() const {return false; }
    private:
        friend class Painter;
};

} // namespace lear

#endif // #ifdef _LEAR_PIMAGE_H_

