"""
definition of the input files 

"""

from funcs import *



all_classes=["mountainAndNotBeach","foliage","rock","conifer","building"]


def get_learn_set(classname):



  if classname=="mountainAndNotBeach":
  
    mountaindir="tex_ims/scenetypes/mountain"
    beachdir="tex_ims/scenetypes/beach"
    
    learnmount=["alin-009-2005-02-22-034.jpg",'alin-009-2005-02-23-013.jpg']
    learnbeach=['186-FF9B6D45-D11D-2E1D-EA10-3F7064ED321A.JPG',
                "558-D6BE4372-B09D-0B5D-0315-709A04F591A9.JPG"]
    mountainimg=[mountaindir+"/"+f for f in learnmount]
    beachimg=[beachdir+"/"+f for f in learnbeach]
    learnset=mountainimg+[(fn,'!') for fn in beachimg]
    
    return learnset
  
  if classname=="foliage":
    ims=[ 380,  374]
    return [("tex_ims/review_selection_sel/%d.jpg"%i,
             "tex_ims/foliage_examples_mask/%d.png"%i) for i in ims]

  if classname=="rock":
    ims=["533","609","inr-010-2006-07-19-10222"]
    return [("tex_ims/rock_examples/%s.jpg"%f,
             "tex_ims/rock_examples_mask/%s.png"%f) for f in ims]

  if classname=="conifer":
    ims=["alin-009-2005-02-22-040","alin-009-2005-02-23-015",
         "alin-009-2005-02-23-020"]
    return [("tex_ims/conifer_examples/%s.jpg"%f,
             "tex_ims/conifer_examples_mask/%s.png"%f) for f in ims]

  if classname=="building":
    ims=["399-916B3EE4-A3F9-991D-B14A-21E8F2F0AF10","407-A1CD7AF5-0867-C982-20C6-2D538E297D71","509-C64934CF-CA9D-04A6-205E-13C6E61DF750"]
    return [("tex_ims/building_examples/%s.JPG"%f,
             "tex_ims/building_examples_mask/%s.png"%f) for f in ims]

def get_test_set(classname):

  #if classname=="mountainAndNotBeach":
  #  return ['tex_ims/PCS-009-Holiday-Mountain-001-049/alin-009-2005-02-26-001.jpg']

  if classname=="mountainAndNotBeach":
    mountainimg=get_files_in("tex_ims/scenetypes2/mountain")
    beachimg=get_files_in("tex_ims/scenetypes2/beach")
    # interlace:
    testimg=[]
    while mountainimg or beachimg:
      if mountainimg:
        testimg.append(mountainimg[0])
        del mountainimg[0]
      if beachimg:
        testimg.append(beachimg[0])
        del beachimg[0]
    return testimg

    
  if classname=="foliage":
    ims=[ 657, 346,  374,  387,  9, 236,  373,  380,  389,  662, 223]
    return ["tex_ims/review_selection_sel/%d.jpg"%i for i in ims]

  if classname=="rock":
    return get_files_in("tex_ims/rock_examples")
  
  if classname=="conifer":
    return get_files_in("tex_ims/conifer_examples_scl")

  if classname=="building":
    return None


def get_gt_set(classname):
  if classname=="mountainAndNotBeach":
  
    mountaindir="tex_ims/scenetypes/mountain"
    beachdir="tex_ims/scenetypes/beach"
    
    learnmount=["alin-009-2005-02-22-034.jpg",'alin-009-2005-02-23-013.jpg']
    learnbeach=['186-FF9B6D45-D11D-2E1D-EA10-3F7064ED321A.JPG',
                "558-D6BE4372-B09D-0B5D-0315-709A04F591A9.JPG"]
    mountainimg=[mountaindir+"/"+f for f in learnmount]
    beachimg=[beachdir+"/"+f for f in learnbeach]
    learnset=mountainimg+[(fn,'!') for fn in beachimg]
    
    return learnset
  
  if classname=="foliage":
    ims=[ 657, 346,  374,  387,  9, 236,  373,  380,  389,  662, 223]
    return [("tex_ims/review_selection_sel/%d.jpg"%i,
             "tex_ims/foliage_examples_mask/%d.png"%i) for i in ims]

  if classname=="rock":
    return [("tex_ims/rock_examples/%s"%f,
             "tex_ims/rock_examples_mask/%s.png"%f[:-4])
            for f in os.listdir("tex_ims/rock_examples")
            if f.find('.jpg')!=-1]
  
  if classname=="conifer":
    ims=["alin-009-2005-02-22-040","alin-009-2005-02-23-015",
         "alin-009-2005-02-23-020"]
    return [("tex_ims/conifer_examples/%s.jpg"%f,
             "tex_ims/conifer_examples_mask/%s.png"%f) for f in ims]

  if classname=="building":
    return [("tex_ims/building_examples/%s.JPG"%f[:-4],
             "tex_ims/building_examples_mask/%s.png"%f[:-4])
            for f in os.listdir("tex_ims/building_examples_mask")
            if f[-4:]=='.png']
