/***************************************************************************
                            Classifier.h
                             ------------------
    begin                : 15.01.2006
    copyright            : (C) 2006 by Frank Moosmann
    email                : frank.moosmann@inrialpes.fr
 ***************************************************************************/

#ifndef CLASSIFIER_H
#define CLASSIFIER_H

#include "FeatureVector.h"
#include "ClassLabel.h"
#include "ClassLabelHistogram.h"
#include <list>

class Classifier {

public:

  virtual ~Classifier() {};
  virtual void writeToFile(std::string filename) = 0;
  virtual ClassLabel classify (std::list<FeatureVector*>* featureVec, ClassLabelHistogram* totalVotes = 0, ClassLabelHistogram* windowVotes = 0, bool saveAllClassHistograms=false) = 0;
  
  std::list<ClassLabel> classLabelList;  // list with all the classLabels used (should be set up in the constructor)
  double getLastConfidenceValue() {return confidenceValue;};

private:

protected:
  double confidenceValue;
};
#endif //CLASSIFIER_H
