/***************************************************************************
                            DecisionNode.h
                             ------------------
    begin                : 07.11.2005
    copyright            : (C) 2005 by Frank Moosmann
    email                : frank.moosmann@inrialpes.fr
 ***************************************************************************/
 
#ifndef DECISIONNODE_H
#define DECISIONNODE_H

#include "TreeNode.h"

class DecisionNode : public virtual TreeNode {
public:  
  DecisionNode(int attributeNo, int attributeNo2, FeatureData splitThreshold, TreeNode* nodeAttributeSmaller, TreeNode* nodeAttributeGE, double scoreVal, unsigned int treeLevel);
  virtual ~DecisionNode(); // will delete whole subtree!!!

  virtual TerminalNode* classify (FeatureVector* featureVec, bool addFVecInfo);
  virtual void writeToFile(std::ostream *out);

  int attrNo;
  int attrNo2;
  FeatureData threshold;
  TreeNode* nodeAttSmaller;
  TreeNode* nodeAttGE;
  
  static unsigned int totalDecisionNodeCount;

private:
  //none
};
#endif //DECISIONNODE_H


