/***************************************************************************
                                IntegralImage.h
                             ------------------
    begin                : 01.12.2005
    copyright            : (C) 2005 by Frank Moosmann and INRIA
    email                : moosmann@mrt.uka.de
 ***************************************************************************/

#ifndef INTEGRALIMAGE_H
#define INTEGRALIMAGE_H

#include <Magick++.h>

class IntegralImage {

public:
  
  enum ExtractionMethod {
    ColorHSL, ColorRGB, Greyscale, BlackWhite
  };
  
  IntegralImage(Magick::Image img, ExtractionMethod extMethod);
  ~IntegralImage();
  
  double getIntegral(unsigned int x, unsigned int y, unsigned int colorChannel);
  double getIntegralArea(unsigned int x, unsigned int y, unsigned int width, unsigned int height, unsigned int colorChannel);
  void printIntoFile(std::string filename);  // for debug purposes
  unsigned int getNoChannels();

private:
  double ***integralImage;
  unsigned int imWidth;
  unsigned int imHeight;
  unsigned int noChannels;
};
#endif //INTEGRALIMAGE_H
