/***************************************************************************
                                TreeNode.h
                             ------------------
    begin                : 07.11.2005
    copyright            : (C) 2005 by Frank Moosmann
    email                : frank.moosmann@inrialpes.fr
 ***************************************************************************/

#ifndef TREENODE_H
#define TREENODE_H

#include "ClassLabel.h"
#include "FeatureVector.h"
#include <ostream>

class TerminalNode;

class TreeNode {

public:
  
  virtual ~TreeNode() {};
  virtual TerminalNode* classify (FeatureVector* featureVec, bool addFVecInfo) = 0;
  virtual void writeToFile (std::ostream *out) = 0;
  //virtual void writeToFile (ostream *out) = 0;
  
  TreeNode *parent;
  unsigned int level;
  double score;

};
#endif //TREENODE_H
